# serviceaccount

![Version: 0.1.0](https://img.shields.io/badge/Version-0.1.0-informational?style=flat-square)

Provides simplified syntax for management of:
- service accounts
- roles
- role bindings

Allows:
- simplified declaration of sa/role/rb combos
- create account & bind to to existing role
- create role & bind it to existing accounts (local/external)

## Accounts

Simple declaration of accounts:

```yaml
accounts:
  account1: {}
  account2: {}
```

## Roles

Declare roles:

```yaml
roles:
  $role1:
    rules:
    - apiGroups: []
      resources: []
      verbs: []
```

## Role Bindings

**Implicit role bindings**

```yaml
useImplicitRoleBindings: true
accounts:
  deployer: {}
roles:
  deployer:
    rules: [...]
```

This will create deployer combo for service account + role + role binding

**Grant role to existing service account(s)**

```yaml
roles:
  deployer:
    rules: [...]
    accounts:
    - default
    - other-namespace/service-account-name
```

**Grant existing role to managed service account**

```yaml
accounts:
  deployer:
    roles:
    - existing-role-name
```

## Service Account Tokens

Since Kubernetes 1.24+, service account tokens are not automatically created/generated for new service accounts.

This helm chart will generate tokens for managed service accounts, if needed and/or forced.

```yaml
createServiceAccountToken: ~ # true=force, false=disable, default=autodetect
```

## Cluster Roles + Cluster Role Bindings

Out of scope / Intentionally unsupported by this chart.

## Values

| Key | Type | Default | Description |
|-----|------|---------|-------------|
| accounts | object | `{}` |  |
| createServiceAccountToken | string | `nil` |  |
| roles | object | `{}` |  |
| useImplicitRoleBindings | bool | `true` |  |
| useReleasePrefix | bool | `true` |  |

----------------------------------------------
Autogenerated from chart metadata using [helm-docs v1.12.0](https://github.com/norwoodj/helm-docs/releases/v1.12.0)